// TextPipeEngineDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxdlgs.h>
#include "TextPipeEngineDemo.h"
#include "TextPipeEngineDemoDlg.h"
#include ".\TextPipeEngineDemodlg.h"
//#include ".\TextPipeEngineDemodlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//#include "textpip"


// CTextPipeEngineDemoDlg dialog



CTextPipeEngineDemoDlg::CTextPipeEngineDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextPipeEngineDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_strFilterName = "c:\\bp\\textpipe\\engine database test.fll";
	m_strInputText = "The quick brown fox jumped over the lazy dog.";
	m_strOutputText = "";
}

void CTextPipeEngineDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTextPipeEngineDemoDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_EDITBUTTON, OnBnClickedEditbutton)
	ON_BN_CLICKED(IDC_OPENBUTTON, OnBnClickedOpenbutton)
	ON_BN_CLICKED(IDC_RUNBUTTON, OnBnClickedRunbutton)
END_MESSAGE_MAP()


// CTextPipeEngineDemoDlg message handlers

BOOL CTextPipeEngineDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this oautomatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Setting text fields
	SetDlgItemText(IDC_FilterFileName, m_strFilterName);
	SetDlgItemText(IDC_INPUTTEXT, m_strInputText);
	SetDlgItemText(IDC_OUTPUTTEXT, m_strOutputText);

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTextPipeEngineDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTextPipeEngineDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
void CTextPipeEngineDemoDlg::OnBnClickedEditbutton()
{
	char filename[MAX_PATH];
	int exist = GetDlgItemText(IDC_FilterFileName, filename, MAX_PATH);
	if (exist)
	{
		HANDLE hFile;
		hFile = CreateFile(TEXT(filename), GENERIC_READ, FILE_SHARE_READ, NULL, 
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile == INVALID_HANDLE_VALUE) 
		{ 
			MessageBox("File " + CString(filename) + " doesn't exists!", "TextPipeEngineDemoC++", MB_OK);
			return;
		}
		CloseHandle(hFile);
		ShellExecute(NULL, "open", LPCTSTR(filename), "", "", SW_SHOW);
	}
	else
	{
		MessageBox("You didn't specified a filter file!", "TextPipeEngineDemoC++", MB_OK);
		return;
	}
}

void CTextPipeEngineDemoDlg::OnBnClickedOpenbutton()
{
	OPENFILENAME ofn = {sizeof(OPENFILENAME)};
	ofn.hwndOwner = GetSafeHwnd();
	ofn.hInstance = theApp.m_hInstance;
	ofn.lpstrFilter = "TextPipe Filter Files(*.fll)\0*.fll\0";
	char szBuf[MAX_PATH] = {0};
	char szTitle[] = "Open Filter";
	ofn.lpstrFile = szBuf;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrFileTitle = szTitle;	
	ofn.nMaxFileTitle = lstrlen(szTitle);
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if (GetOpenFileName(&ofn))
	{
		SetDlgItemText(IDC_FilterFileName, ofn.lpstrFile);
	}
}

void CTextPipeEngineDemoDlg::OnBnClickedRunbutton()
{
	CoInitialize(NULL);
	TPEngine::IApplicationPtr spApp = NULL;
	TPEngine::IFilterWindowPtr spFilterWnd = NULL;
	HRESULT hr = S_OK;
	char buff[MAX_PATH];

	hr = spApp.CreateInstance(TPEngine::CLSID_Application);
	if (hr != S_OK || spApp == NULL)
	{
		MessageBox("Error - Can't create Application", "TextPipeEngineDemoC++", MB_OK);
		return;	
	}
	spFilterWnd = spApp->newWindow();
	int written = GetDlgItemText(IDC_FilterFileName, buff, MAX_PATH);
	if (written)
	{
		_bstr_t bstrFilterName(buff);
		VARIANT_BOOL vtbRes = VARIANT_TRUE;
		vtbRes = spFilterWnd->openFilter(bstrFilterName);
		_bstr_t bstrError = spFilterWnd->GeterrorText();
		if (bstrError.length())
		{
			MessageBox("Error - openFilter error", "TextPipeEngineDemoC++", MB_OK);
			return;
		}
		/*
		spFilterWnd->inputMode = 1;
		bstrError = spFilterWnd->GeterrorText();
		if (bstrError.length())
		{
		MessageBox("Error - openFilter error", "TextPipeEngineDemoC++", MB_OK);
		return;
		}
		spFilterWnd->addFile(L"c:\\test.txt", 0, 1);
		bstrError = spFilterWnd->GeterrorText();
		if (bstrError.length())
		{
		MessageBox("Error - openFilter error", "TextPipeEngineDemoC++", MB_OK);
		return;
		}
		spFilterWnd->outputMergeFile = L"c:\\test.dcv";
		bstrError = spFilterWnd->GeterrorText();
		if (bstrError.length())
		{
		MessageBox("Error - openFilter error", "TextPipeEngineDemoC++", MB_OK);
		return;
		}
		spFilterWnd->saveFilter(L"c:\\audit.fll");
		bstrError = spFilterWnd->GeterrorText();
		if (bstrError.length())
		{
		MessageBox("Error - openFilter error", "TextPipeEngineDemoC++", MB_OK);
		return;
		}
		spFilterWnd->setInputTrialRun();
		bstrError = spFilterWnd->GeterrorText();
		if (bstrError.length())
		{
		MessageBox("Error - openFilter error", "TextPipeEngineDemoC++", MB_OK);
		return;
		}
		spFilterWnd->execute();
		*/
		GetDlgItemText(IDC_INPUTTEXT, m_strInputText);
		BSTR bstrOutput;
		bstrOutput = spFilterWnd->processString(_bstr_t((LPCSTR)m_strInputText));
		m_strOutputText = bstrOutput;
		SetDlgItemText(IDC_OUTPUTTEXT, m_strOutputText);
	}
}
